

import java.util.*;
import java.awt.*;
import java.awt.geom.*;

public class Grid implements Common{

	int id = -1;
	double x,y, xlen, ylen;
	boolean isLocal = false;
	boolean isInner = false;
	boolean isOuter = false;
	Color c;

	public Grid(){
		this.id = 0;
		this.x = 0.0;
		this.y = 0.0;
		this.xlen = 0;
		this.ylen = 0;
		this.isLocal = false;
		this.isInner = false;
		this.isOuter = false;
		if (this.isOuter)
			this.c = Color.blue;
		else
			this.c = Color.gray;
	}
	public Grid(int id, double x, double y){
		this.id = id;
		this.x = x;
		this.y = y;
		this.xlen = GRID_WIDTH;
		this.ylen = GRID_HEIGHT;
		this.isLocal = false;
		this.isInner = false;
		this.isOuter = false;
		if (this.isOuter)
			this.c = Color.blue;
		else
			this.c = Color.gray;
	}
	public Grid(int id, double x, double y, int layer){
		this.id = id;
		this.x = x;
		this.y = y;
		this.xlen = GRID_WIDTH;
		this.ylen = GRID_HEIGHT;
		this.isLocal = false;
		this.isInner = false;
		this.isOuter = false;

		if (layer == INNER_LAYER)
			this.isInner = true;
		else if (layer == LOCAL_LAYER)
			this.isLocal = true;
		else
			this.isOuter = true;

		if (this.isOuter)
			this.c = Color.blue;
		else
			this.c = Color.gray;
	}
	public Grid(int id, double x, double y, Color c){
		this.id = id;
		this.x = x;
		this.y = y;
		this.xlen = GRID_WIDTH;
		this.ylen = GRID_HEIGHT;
		this.c = c;
	}
	public Grid(int id, double x, double y, double xlen, double ylen){
		this.id = id;
		this.x = x;
		this.y = y;
		this.xlen = xlen;
		this.ylen = ylen;
		this.c = c;
	}
	public boolean isLocal(){
		return isLocal;
	}
	public boolean isInner(){
		return isInner;
	}
	public boolean isOuter(){
		return isOuter;
	}
	public int getID(){
		return id;
	}
	public double getX(){
		return x;
	}
	public double getY(){
		return y;
	}
	public double getXLen(){
		return xlen;
	}
	public double getYLen(){
		return ylen;
	}
	public Color getColor(){
		return c;
	}
}




